 ODAPI Configuration Utility

The Object Database Application Programming Interface (ODAPI) is the database engine that accesses and delivers your data. To do this properly, ODAPI needs information about your specific environment. This information is stored in the ODAPI configuration file. Use the ODAPI Configuration Utility to change the settings in this configuration file.

Options	Click the Options button to open the Basic Options dialog box where you can change your network control file or your language drivers. You can also change your minimun and maximum buffer size and turn Local share on or off.

Alias	Click the Alias button to open the Alias Manager dialog box where you can add, delete, or modify any of your database aliases.

You can also use System and Drivers menus to change settings used to access your data.

Note:	 You must restart your application for changes made with the ODAPI Configuration Utility to take effect.


File | Open

Choose File | Open to open the Open dialog box where you can select a .CFG file to view or edit. A list of .CFG files contained in the current directory appears below the File Name text box.


Open dialog box

Use the Open dialog box to select a .CFG file to view or edit.

File Name

Enter the name of the .CFG file in the File Name text box and click OK. When a .CFG file is open, its name appears in the title bar.

All of the .CFG files in the current directory are listed in the box below the File Name text box.

List Files of Type

The List Files box displays the type of files listed in the File Name box.

Directories

The Directories text box displays the current directory. Use the directories list below the Directories text box to search for .CFG files in other directories.

Drives

The Drives text box lists the current drive. To change to another drive, click the arrow button and select a driver from the list that is displayed.

File Stats

The File Stats box displays the date and time that the current .CFG file were last modified.

To open the Open dialog box, choose File | Open from the main menu.


File | Save

Choose File | Save to save any changes that have been made with the ODAPI Configuration Utility. The changes take effect when you restart your application.


File | Save As

Choose File | Save As to open the Save As dialog box where you can save the current settings in another .CFG file.


Save As dialog box

Use the Save As dialog box to save the current .CFG settings in another file.

File Name

Enter the name of the new .CFG file in the File Name text box and click OK.

All of the .CFG files in the current directory are listed in the box below the File Name text box.

List Files of Type

The List Files box displays the type of files listed in the File Name box.

Directories

The Directories box lists the current directory. Use the browse box below the Directories box to search for .CFG files in other directories.

Drives

The Drives text box lists the current drive. To change to another drive, click the arrow button and select a driver from the list that is displayed.

File Stats

The File Stats box displays the date and time that the current .CFG file was last modified.

To open the Save As dialog box, choose File | Save As from the main menu.


File | Merge

Use File | Merge to open the Merge another file with current dialog box where you can merge two configuration files.


Merge another file with current dialog box

Use the Merge dialog box to merge two .CFG files. The first file will be the configuration file that is currently open. Enter the name of the second file in the text box provided.

Click the Browse button to open the Browse dialog box where you can locate the .CFG file you want to merge.

See also

Browse dialog box


Browse dialog box

Use the Browse dialog box to locate the .CFG file you want to merge with the current .CFG file.

File Name

When you have located the .CFG file you want to merge, enter its name in the File Name text box and click OK.

All of the .CFG files in the current directory are listed in the list box below the File Name text box.

List Files of Type

The List Files box displays the type of files listed in the File Name box.

Directories

The Directories panel lists the current directory. Use the Directories selection list at the bottom of the panel to search for .CFG files in other directories.

Drives

The Drives text box lists the current drive. To change to another drive, click the arrow button and select a drive from the list that is displayed.

File Stats

The File Stats box displays the date and time that the currently selected .CFG file was last modified.


$ File | Make Current# idh_odapi_filemakecurrent+ brws_pobj:0K Commands; File | Make Current; Current File; Changing files


File | Exit

Choose File | Exit to exit the ODAPI Configuration Utility. If you made changes and did not save them, a warning appears. You can save your changes or exit without saving.


Close ODAPI Config file dialog box

Changes that you have made to the current .CFG file have not been saved. If you want to save the changes, click the Yes button. If you do not want to save the changes click the No button. To continue working in the ODAPI Configuration Utility, click the Cancel button.


System menu

Use the System menu to define the settings ODAPI uses to start your application and to internally convert character strings to date, time, and number values.

Choose	To

Init	modify the settings ODAPI uses to start your application and allocate your Windows resources, such as memory and network use.

Formats	modify the settings ODAPI uses to convert string values into date, time, or number values and to convert these values to character strings. These settings are used when you change a field's type (during Restructure), run queries using selection criteria or pattern matching, and add (or subtract) tables.


System | Init

Choose System | Init to open the SYSTEM.INIT dialog box where you can modify the settings used to access your data and allocate your Windows resources, such as memory and network use.


SYSTEM.Init dialog box

Use the System.Init dialog box to modify the settings used to access your data and allocate your Windows resources, such as memory and network use.

Value

The current value for each setting is displayed in the Value text box. To modify the current value, enter the new value in the Value text box.

Description

A brief description of each setting is provided in the Description text box.

Settings

VERSION	describes the version of ODAPI you're using. This is an internal setting and should not be changed.

LOCAL SHARE	tells ODAPI to perform network-style file locking on a local drive. It is set to TRUE if Local Share is on and FALSE otherwise. The default is FALSE.

MINBUFSIZE	is the minimum amount of memory (in KB) reserved for database data cache. The value can be any integer greater than 32 and less than the total amount of RAM available to Windows. The default is 256. Non-integer values are ignored.

MAXBUFSIZE	is the maximum amount of memory (in KB) allocated for database data cache. The value can be any integer greater than the MINBUFSIZE and less than (or equal to) the total amount of RAM available to Windows. The default is 2048. Non-integer values are ignored.

LANGDRIVER	is the system language driver. Choose a valid language driver. The default is the OEM driver appropriate for your country's version of Windows, for example, ASCII for U.S. workstations.

NET DIR	is the directory containing your network control file (PDOXUSRS.NET). The default is blank. To change this setting, enter an existing directory path.

MAXFILEHANDLES	is the maximum number of file handles ODAPI uses. The value can be any integer ranging from 5 to 256. Higher values improve performance but use more Windows resources. The default is 256.

SYSFLAGS	is a reserved setting used by ODAPI and should not be changed.

SQLQRYMODE	tells ODAPI where to perform queries. This setting can be SERVER or left blank. SERVER tells ODAPI to perform SQL queries on the server. If this setting is left blank then ODAPI will attempt to perform queries on a remote server. If this fails, the query will be attempted locally. This is the default behavior. Note: If SQLQRYMODE is set to SERVER, and the attempt to complete the query on the server is unsuccessful, the query will fail.


System | Formats

Choose System | Formats to display a menu to change the settings used to convert string values into date, time, or number values and to convert these values to character strings.

Note:	We do not recommend changing FORMAT settings unless you need to work with specialized data formats or customize the International settings of Windows Control Panel to values not normally used by your country. If you customize Windows Control Panel, we strongly recommend you make similar changes to your ODAPI FORMAT settings; otherwise queries using selection criteria and pattern matching may return unexpected results.

DATE	opens the System.Formats.Date dialog box where you can change the settings used to format date values.

TIME	opens the System.Formats.Time dialog box where you can change the settings used to format time values.

NUMBER	opens the System.Formats.Number dialog box where you can change the settings used to format number values.


System | Formats | Date

Choose System | Formats | Date to open the System.Formats.Date dialog box where you can change the settings used to format date values.


System.Formats.Date dialog box

Use the System.Formats.Date dialog box to modify the settings used to convert string values into date values. The current value for each setting is displayed in the Value text box. To change the setting, enter the new setting in this same box.

SEPARATOR	is the character used to separate the month, day, and year components of a date value. For example, the value "12/31/92" uses the forward-slash ( / ) as a separator. The default is the character normally used in the country selected in the Windows Control Panel when you install Paradox.

MODE	controls the order of the month, day, and year components and can be 0 (for MDY), 1 (for DMY), or 2 (for YMD). Other values are ignored. The default is the order normally used in the country selected in the Windows Control Panel when you install Paradox.

FOURDIGITYEAR	specifiies the number of digits for the year value (four or two). If TRUE, years are expressed in four digits (For example, 1993). If FALSE, the default, years have two digits (93).

YEARBIASED	tells Paradox whether or not it should add 1900 to years entered as two digits. For example, if TRUE and you enter "7/21/69," Paradox interprets your value as "7/21/1969", otherwise, the date is interpreted as entered (in this case, "7/21/0069"). The default is TRUE.

LEADINGZEROM	specifies whether or not single digit month values have a leading zero. For example, if you enter "1/1/80" and this is set to TRUE , Paradox interprets the date as "01/1/80." If FALSE, the value is "1/1/80." The default is TRUE.

LEADINGZEROD	controls whether or not single digit day values have a leading zero. For example, if you enter "1/1/80" and this is set to TRUE, Paradox interprets the value as "1/01/80." If FALSE, your date is "1/1/80." The default is TRUE.

To open the SYSTEM | FORMATS | DATE dialog box, choose System | Formats | Date from the main menu.


System | Formats | Time

Choose System | Formats | Time to open the System.Formats.Time dialog box where you can change the settings used to format time values.


System.Formats.Time dialog box

Use the System.Formats.Time dialog box to modify the settings used to convert string values into time values. The current value for each setting is displayed in the Value text box. To change the setting, enter the new setting in this same box.

TWELVEHOUR	tells Paradox whether or not time values are expressed using a twelve-hour clock. For example, if TRUE and it is currently 8:21 p.m., the time is "08:21 PM." If FALSE, the time is "20:21." The default is TRUE.

AMSTRING	is the string of characters used to indicate morning (before noon and after midnight) times, when TWELVEHOUR is TRUE. The setting can be any valid string of characters. The default is "AM". If TWELVEHOUR is FALSE, this item is ignored.

PMSTRING	is the string of characters used to indicate express evening (after noon and before midnight) times, when TWELVEHOUR is TRUE. The setting can be any valid string of characters. The default is "PM". If TWELVEHOUR is FALSE, this item is ignored.

SECONDS	specifies whether or not time values include seconds. For example, if this setting is TRUE and it is currently 8:21:35 p.m., the time value is "8:21:35 PM." If FALSE, the time is "8:21 PM". The default is TRUE.

MILSECONDS	specifies whether or not time values include milliseconds. If this setting is TRUE, time values include milliseconds (for example, "8:21:35:54 PM".) If FALSE, time values do not include milliseconds. The default is FALSE.

To open the SYSTEM.FORMATS.TIME dialog box, choose System | Formats | Time from the main menu.


System | Formats | Number

Choose System | Formats | Number to open the System.Formats.Number dialog box where you can change the settings used to format number values.


System.Formats.Number dialog box

Use the System.Formats.Number dialog box to modify the settings used to convert string values to number values. The current value for each setting is displayed in the Value text box. To change the setting, enter the new setting in this same box.

DECIMALSEPARATOR	is the character used to separate the decimal portion of a number from its integer portion. For example, in 3.14, a period ( . ) separates the decimal portion (14) from the integer (3). This can be any valid character and defaults to the standard decimal separator used in the country selected in the Windows Control Panel when you install Paradox.

THOUSANDSEPARATOR	is the character used to separate large numbers into their "thousands" components. For example, in 1,000,000.00, commas (,) separate the millions and thousands components. This can be any valid character and defaults to the standard thousands separator used in the country where you bought Paradox.

DECIMALDIGITS	determines how many digits to the right of the decimal point will be held when converting string values to number values.

LEADINGZERON	indicates whether numbers between 1 and -1 have a leading zero to the left of the decimal. For example, if your value is .14 and this setting is TRUE, your value is 0.14. If FALSE, there is no leading zero (.14). The default is TRUE.

To open the SYSTEM.FORMATS.NUMBER dialog box, choose System | Formats | Number from the main menu.


Drivers menu

Use the Drivers menu to modify the settings that ODAPI uses to determine how your application creates, sorts, and handles your tables.

Choose the type of table that you will be opening from the menu.


Drivers | Paradox

Choose Drivers | Paradox to modify the way your Paradox tables are created, sorted and handled.

Init	Opens the Drivers.Paradox.Init dialog box where you can modify the initialization parameters used for Paradox tables (.DB).

Note: Because the INIT section contains internal settings, we do not recommend changing the values of its items, except as previously described.

Table Create	Opens the Drivers.Paradox.Table Create dialog box where you modify the settings that control the settings of Paradox tables.


Drivers | Paradox | Init

Choose Drivers | Paradox | Init to open the Drivers.Paradox.Init dialog box where you can modify the initialization parameters used for Paradox tables (.DB).


Drivers.Paradox.Init dialog box

Use the Paradox Drivers Init dialog box to modify the initialization parameters used for Paradox tables (.DB).

Value

The current value for each setting is displayed in the Value text box. To modify the current value, enter the new value in the Value text box.

Description

A brief description of each setting is provided in the Description text box.

Settings

VERSION	is the Borland-internal version number of your ODAPI Paradox driver. This is for internal use only; do not modify it.

TYPE	describes the type of Paradox driver being used by ODAPI. Currently, this can only be FILE. This is an internal setting; do not modify it.

LANGDRIVER	is the default language driver for Paradox tables. Choose the internal name of any Paradox language driver listed in the ODAPI language drivers; however, we recommend setting this item from the ODAPI Configuration Utility dialog box.

When changing language drivers you must enter the new driver's internal name. The Supported Paradox Language Drivers table shows both names for all language drivers that are currently supported.


Drivers | Paradox | Table Create

Choose Drivers | Paradox | Table Create to open the Drivers.Paradox.Table Create dialog box where you can control the settings of Paradox tables.


Paradox Drivers Table Create dialog box
Drivers.Paradox.Table Create dialog box

Use the Drivers.Paradox.Table Create dialog box to control the settings of Paradox tables.

Value

The current value for each setting is displayed in the Value text box. To modify the current value, enter the new value in the Value text box.

Description

A brief description of each setting is provided in the Description text box.

Settings

LEVEL	is the table format used to create temporary Paradox tables and can be 4 for the Standard table format introduced in Paradox 4.0 or 3 for the Compatible table format used by Paradox 3.5 and earlier versions. The default is 4.

Note: To use BLOB fields, secondary indexes, and referential integrity, you must create a level-4 table.

BLOCK SIZE	is the size of disk blocks used to store records. When you create a table, Paradox allocates disk space in blocks. This can be 1024, 2048, 3072, or 4096. The default is 2048.

FILL FACTOR	is a percentage value that determines when Paradox allocates another disk block for index files. When an index has filled this amount of the current disk block, Paradox allocates another disk block for the file. Smaller values offer better performance, but increase the size of your indexes. Larger values give smaller index files, but increase the time needed to create an index. The value can be any integer ranging from 1 to 100. The default is 95.

STRICTINTEGRTY	determines whether or not applications that do not support referential integrity (for example, Paradox 4.0) can modify tables using that feature. For example, if TRUE and you attempt to change a table with referential integrity in Paradox 4.0, you receive an error message. If FALSE, you can change the table, but you risk the integrity of your data. The default is TRUE.


Drivers | dBASE

Choose Drivers | dBASE to modify the settings used for dBASE tables.

Init	Opens the Drivers.dBASE.Init dialog box where you can modify the initialization parameters used for dBASE tables.

Note: Because the INIT section contains internal settings, we do not recommend changing the values of its items, except as previously described.

Table Create	Opens the Drivers.dBASE.Table Create dialog box where you can control the settings for new dBASE tables.


Drivers | dBASE | Init

Choose Drivers | dBASE | Init to open the Drivers.dBASE.Init dialog box where you can modify the initialization parameters used for dBASE tables (.DBF).


Drivers.dBASE.Init dialog box

Use the Drivers.dBASE.Init dialog box to modify the initialization parameters used for dBASE tables (.DBF).

Note:	Because the INIT section contains internal settings, we do not recommend changing the values of its items, except as previously described.

Value

The current value for each setting is displayed in the Value text box. To modify the current value, enter the new value in the Value text box.

Description

A brief description of each setting is provided in the Description text box.

Settings

VERSION	is the Borland-internal version number of your ODAPI dBASE driver. This is for internal use only; do not modify it.

TYPE	describes the type of dBASE driver being used by ODAPI. Currently, this can only be FILE. This is an internal setting; do not modify it.

LANGDRIVER	is the current language driver for dBASE tables. You can choose the internal name of any dBASE language driver; however, we recommend setting this item from the ODAPI Configuration Utility dialog box.

When changing language drivers you must enter the new driver's internal name. The Supported dBASE Language Drivers table shows both names for all language drivers that are currently supported.


Drivers | dBASE | Table Create

Choose Drivers | dBASE | Table Create to open the Drivers.dBASE.Table Create dialog box where you can control the settings for new dBASE tables.


dBASE Drivers Table Create dialog box
Drivers.dBASE.Table Create dialog box

Use the Drivers.dBASE.Table Create dialog box to control the settings for new dBASE tables.

Value

The current value for each setting is displayed in the Value text box. To modify the current value, enter the new value in the Value text box.

Description

A brief description of each setting is provided in the Description text box.

Settings

LEVEL	is the table format used to create dBASE temporary tables and can be 4 for the dBASE IV table format or 3 for the table format used in dBASE III and dBASE III Plus. The default is 4.

MDX BLOCK SIZE	is the size of disk blocks (in bytes) Paradox allocates for .MDX files. The value can be any integer that is a multiple of 512. The default is 1024.

MEMO FILE BLOCK	is the size of disk blocks (in bytes) Paradox allocates for memo (.DBT) files. The value can be any integer that is a multiple of 512. The default is 1024.


Remote database servers

The Driver you have selected is for a remote database server. Please see your Borland SQL Link documentation for details on these drivers and other settings.


Basic Options dialog box

The Basic Options dialog box lets you change some of the settings of your .CFG file.

Network Control File Directory

Enter the complete path of the PDOXUSRS.NET file. This path should be set to a subdirectory on your network that is accessible to every user who will share Paradox tables. Each user must set this path individually.

Any additional applications used to access Paradox tables on a network must also use the same network file specified here.

System Language Driver

Select the driver to use as a default if the Paradox and dBASE language drivers are undefined.

Paradox Language Driver

Select the driver that will determine the sort order, capitalization, and string comparison conventions that are specific to your country's language for Paradox tables. The default for users in the United States is the Paradox ASCII driver.

dBASE Language Driver

Select the driver that will determine the sort order, capitalization, and string comparison conventions that are specific to your country's language for dBASE tables. The default for users in the United States is the EnUS dBASE 437 driver.

Note:	If you open a dBASE IV 2.0 table that uses a different language driver than the one selected for the dBASE Language Driver Basic Option, ODAPI uses the table's language driver for character conversion, case conversion, and sorting (collation) operations. ODAPI does not contain individual settings to control ASCIISORT or LANGDRIVER.

Buffer Size (in Kilobytes)

Specify a range for the size of the database cache.

Minimum	Specify the minimum amount of memory you want available. The minimum valid value for this is 32. The default is 256.

Maximum	Specify the maximum amount of memory you want available. The maximum valid value for this is 65535. The default is 2048.

Local Share

Local Share is On	lets you safely share tables with non-ODAPI applications that you are running locally. If you select this option, make sure that SHARE.EXE is loaded before starting your application, or your application won't start.

Local Share is Off	turns off the data locks set by Local share. If you are sharing data with non-ODAPI applications, this leaves you unprotected from data corruption. This option provides a performance increase in accessing local data. The default is Local Share is off.


Alias Manager dialog box

Use the Alias Manager dialog box to add, delete, or modify a database alias.

Existing Aliases

The Existing Aliases text box lists all of the available aliases.

Modify

Click the Modify button to open the databases dialog box where you can modify the currently selected alias.

Add

Click the Add button to open the Add New Alias dialog box where you can add new aliases.

Delete

Click the Delete button to remove the currently selected alias. If you have chosen the correct alias, click OK in the warning dialog box.

To open the Alias Manager dialog box, press the Aliases button from the ODAPI Configuration Utility desktop.


Modify dialog box
DATABASES.aliasname dialog box

Use the databases.aliasname dialog box to edit the parameters listed in the Parameter Categories text box.

Select the Parameter Category that you want to edit and click the Edit button. For example, selecting DB INFO and clicking the edit button opens the DATABASES.aliasname.DBINFO dialog box where you can edit the settings of the currently selected alias. You can also click the Edit button to view the current settings for an alias.


databases.aliasname.db info dialog box

Use the DATABASES.aliasname.DB INFO dialog box to modify the settings for the currently selected alias. The settings that can be modified are listed in the Settings text box.

TYPE	is the type of alias that has been defined. The TYPE should not be modified by the user.

PATH	indicates the directory path the alias represents.

When you select a setting to modify, the current value for that setting appears in the Value text box and a brief description of the setting appears in the Description text box.


Add New Alias dialog box

Use the Add New Alias dialog box to create a new alias for your database.

New Alias Name

Enter the alias name in the New Alias name text box.

Alias Type

The Alias type text box displays the type of table your new alias will be assigned to. The default type is Standard. To change the type, click the arrow on the Type text box and choose from the types listed.


Delete Alias dialog box

Use the Delete Alias dialog box to verify that you want to remove an alias and the correct alias is being deleted.

If you do not want to delete the currently selected alias, click Cancel.

If you do want to delete the currently selected alias, click OK.


Supported Paradox Language Drivers

The following table shows the language drivers you can use for Paradox tables, along with the code page for each driver. Advanced users can enter the internal name in the Drivers.Paradox.Init dialog box.

Driver name	Internal	Code Page

Paradox 'ascii'	ascii	437

Paradox 'ESP 437'	spanish	437

Paradox 'intl'	intl	437

Paradox 'intl850'	intl850	850

Paradox 'ISL 861'	iceland	861

Paradox 'nordan'	nordan	865

Paradox 'nordan40'	nordan40	865

Paradox 'swedfin'	swedfin	437


Supported dBASE Language Drivers

The following table shows the language drivers you can use for dBASE tables. The number in the driver name indicates the code page for that driver. Advanced users can enter the internal name in the Drivers.dBASE.Init dialog box. The language or country supported by each language driver is also shown.

Driver name	Internal	Language

Da dBASE 865	DB865DA0	Danish

De dBASE 437	DB437DE0	German

EnUK dBASE 437	DB437UK0	English (U.K)

EnUS dBASE 437	DB437US0	English (U.S.)

Es dBASE 437	DB437ES1	Spanish

Fi dBASE 437	DB437FI0	Finnish

Fr dBASE 437	DB437FR0	French

FrCA dBASE 850	DB850CF0	French (Canadian)

FrCA dBASE 863	DB863CF1	French (Canadian)

It dBASE 437	DB437IT0	Italian

NI dBASE 437	DB437NL0	Dutch

No dBASE 437	DB437NO0	Norwegian

Pt dBASE 850	DB850PT0	Portuguese (Brazilian)

Pt dBASE 860	DB860PT0	Portuguese

Sv dBASE 437	DB437SV0	Swedish